"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = require("assert");
const src_1 = require("../src");
class State extends src_1.Enumify {
    constructor(props) {
        super();
        Object.defineProperties(this, Object.getOwnPropertyDescriptors(props));
    }
    accept(x) {
        throw new Error('Must be overridden');
    }
}
exports.State = State;
State.start = new State({
    done: false,
    accept(x) {
        if (x === '1') {
            return State.one;
        }
        else {
            return State.start;
        }
    },
});
State.one = new State({
    done: false,
    accept(x) {
        if (x === '1') {
            return State.two;
        }
        else {
            return State.start;
        }
    },
});
State.two = new State({
    done: false,
    accept(x) {
        if (x === '1') {
            return State.three;
        }
        else {
            return State.start;
        }
    },
});
State.three = new State({
    done: true,
});
State._ = State.closeEnum();
function run(state, inputString) {
    const trace = [];
    for (const ch of inputString) {
        if (state.done) {
            break;
        }
        state = state.accept(ch);
        trace.push(`${ch} --> ${state}`);
    }
    return trace;
}
test('run', () => {
    assert_1.strict.deepEqual(run(State.start, '01011100'), [
        '0 --> State.start',
        '1 --> State.one',
        '0 --> State.start',
        '1 --> State.one',
        '1 --> State.two',
        '1 --> State.three',
    ]);
});
//# sourceMappingURL=state.js.map